;########################################################################
; ParentOwner by kero
; draft v.2015-01-23
; (corrected for Win95)
;########################################################################

; RealChildWindowFromPoint_
; GetAncestor_
; GetGaParent
; GetGaRoot
; GetGaParent
; NewEdit
; NewCombol
; NewStatic
; NewStatic2
; EnCh
; CreateToolhelp32Snapshot_
; Process32First_
; Process32Next_
; Winfo
; EnumThreadWindowsProc
; EnumChildWindowsProc
;; EnumWindowsProc
; UndoRedo
; FullUndo
; OwnerInfo
; StyleTrigger
; WndProc
; DlgProc2
; CombolCaption
; FillCombo
; OnInitDialog
; OnTimer
; OnCommand
; DlgProc

;########################################################################

.386
.model flat,stdcall
option casemap:none

.const
; __UNICODE__  equ  1
     idm_help	 equ  0EEE0h

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib  user32
inclib  kernel32
inclib  gdi32
inclib	shlwapi
inclib	comctl32

.data
prehelp			db "  //  Drag 'n' Drop  this  Help  window  //  Right-click  =>  close  Help  //  ",13,10,13,10
help				db "  Window  Relationships :      Parent/Child ,   Owner/Owned ,   Z/Enum-order          //    v.2015-01-23",0,13,10
						db 13,10,"  [Usage]",13,10
						db 13,10,"  Right-click  to  any  control   =>   enable / disable  this  control",13,10
            db 13,10,"  Key F8  (when 'lock' is unchecked)   =>   fix  window  under  cursor  to 'Window'  +  check 'lock'"
            db 13,10,"  Key F9   =>   fix  window  under  cursor  to 'Parent|Owner'  +  store cursor's  point (x,y)",13,10
						db 13,10,"  F8 + F9  +  Close   =>   exit  without  restoration",13,10
						db 13,10,"  Check / uncheck  'real'   =>   use  ChildWindowFromPoint / RealChildWindowFromPoint",13,10
						db 13,10,"  Combobox   =>   stored  filtered  window  tree"
						db 13,10,"  Right-click  to  selected  combobox  item   =>   fix  window  from  item  to  'Window'  +  check 'lock'"
						db 13,10,"  Left-click  to  selected  combobox  item   =>   fix  window  from  item  to  'Parent|Owner'",13,10
						db 13,10,"  'M /'   =>   filtered  window  tree  monitor  (based  on  combobox's  combol)  on/off",13,10
            db 13,10,"   Window  filters :"
						db 13,10,"    'All'     =>   all  (+ message-only)  windows"
						db 13,10,"    'Top-L'   =>   all  top-level  windows  (+ message-only)"
						db 13,10,"    'Branch'  =>   root branch  of  window  tree"
						db 13,10,"    'Pid'     =>   all  windows  of  process"
						db 13,10,"    'Tid'     =>   all  windows  of  thread"
						db 13,10,"    'Point'   =>   all  windows  under  stored  point",13,10
						db 13,10,"  'sWaP'  (when 'lock' is checked)  =>  swap  'Window'  and  'Parent|Owner'"
						db 13,10,"  'P'/'W' ('Parent|Owner'/'Window')  =>  choose  target  for  control's  functions",13,10
						db 13,10,"  For  target:"
						db 13,10,"    'Pop /'          =>   WS_POPUP   on/off"
						db 13,10,"    'Child /'        =>   WS_CHILD   on/off"
						db 13,10,"    'min /'          =>   minimize / restore"
						db 13,10,"    'Vis / Hid'      =>   Visible / Hidden"
						db 13,10,"    'En / Dis'       =>   Enable / Disable"
						db 13,10,"    'ClipChild +/-'  =>   WS_CLIPCHILDREN   on/off"
						db 13,10,"    'Tool/'          =>   WS_EX_TOOLWINDOW   on/off"
						db 13,10,"    'App/'           =>   WS_EX_APPWINDOW   on/off"
						db 13,10,"    'Text'           =>   set  text  from   combo"
						db 13,10,"    'Id'             =>   set  Id  from   combo"
						db 13,10,"    'X'              =>   post  WM_CLOSE"
						db 13,10,"    'Up', 'Down', 'Topmost', 'Notopmost', 'Top', 'Bottom'   =>   change  Z-position"
						db 13,10,"    'First', 'Prev', 'Next', 'Last'   =>   set  new  target  from  siblings",13,10
						db 13,10,"  Window  stile  symbols:"
						db 13,10,"    L   WS_EX_LAYERED"
						db 13,10,"    T   WS_EX_TOPMOST"
						db 13,10,"    C   WS_CHILD"
						db 13,10,"    P   WS_POPUP"
						db 13,10,"    O   Overlapped  (not WS_CHILD + not WS_POPUP)"
						db 13,10,"    X   WS_CHILD + WS_POPUP,  forbidden :-)"
						db 13,10,"    m   mINIMIZED"
						db 13,10,"    M   Maximized"
						db 13,10,"    V   Visible"
						db 13,10,"    H   Hidden"
						db 13,10,"    D   Disabled"
						db 13,10,"    E   Enabled",13,10
						db 13,10,"  Window  tree  symbols:"
						db 13,10,"    +   child"
						db 13,10,"    ?   Tid (child) != Tid (parent)"
						db 13,10,"    .   top-level"
						db 13,10,"    !   Tid (top-level) == Tid (Desktop)"
						db 13,10,"    =   top  top-level  (notopmost)"
						db 13,10,"    o   message-only",13,10
						db 13,10,"  -----------"
						db 13,10,"  Init: v.2006-06-06"						
						db 13,10,"   kero <geosities.com/xmemor>"
_line       db 13,10,0
text     		db 13,10,13,10
            db "  W-indow                 <F8>",13,10
						db "  P-arent|'Owner'         <F9>",13,10,13,10
						db "  GetWindow     :gw_Owner",13,10
						db "  GetWindowLong :gwl_hwndParent",13,10
						db "  GetParent",13,10
						db "  GetAncestor   :ga_Parent",13,10
            db " 'GetGaParent'",13,10
						db " 'GetGaRoot'",13,10
						db "  GetAncestor   :ga_Root",13,10
						db "  GetAncestor   :ga_RootOwner",13,10
						db "  GetWindow     :gw_enabledPopup",13,10
						db "  GetLastActivePopup",13,10
						db "  GetWindow     :gw_Child",13,10
						db "  GetWindow     :gw_hwndNext",13,10
						db "  GetWindow     :gw_hwndPrev",13,10
						db "  GetWindow     :gw_hwndLast",13,10
						db "  GetWindow     :gw_hwndFirst",0
hlp					db "About + Help",0
DlgName 		db "Dlg",0
DlgName2 		db "Dlg2",0
DlgName3 		db "Dlg3",0
_wndclass   db "19111018",0
_btntxt     db "+ / -   WS_POPUP",0
_static     db "Static",0
_button			db "Button",0
_edit				db "edit",0
_combolbox	db "combolbox",0
_HWND_MESS	db 13,10," HWND_MESSAGE",0
_HWND_DESK	db "HWND_DESKTOP",0
_mb         db "MsgBox",0
_Owner			db "Owner :",0
_Modal			db "Modal",0
_Modeless		db "Modeless",0
_Popup			db "WS_POPUP",0
_Overlapped	db "not  WS_POPUP",0
_hwnd1      db "hwnd.1",0
_hwnd3      db "hwnd.3",0
_user32                    db "user32",0
_GetAncestor               db "GetAncestor",0
_RealChildWindowFromPoint  db "RealChildWindowFromPoint",0
_kernel32                  db "kernel32",0
_Process32First            db "Process32First",0
_Process32Next             db "Process32Next",0
_CreateToolhelp32Snapshot  db "CreateToolhelp32Snapshot",0
;
head				db " hWnd       Enum   Styles  Id/hM   Tid   'Class'  [x,y,width*height]   Pid   'Exe' - 'Text'",13,10,0
ft      		db 13,10,"%9.8lx  %s%.4d  %s   %4.4lx   %.4d  '%s'   [%d,%d,%d*%d]  %.4d  '%s' - '%s'",0
ft1					db "%10.8lx  _  %s  Dialog  Box  %d",0
ft2					db "%10.8lx  _  Window  %d",0
ft3					db "%s  %8.8lx    '%s'     '%s'",0
ft4					db "%8.8lX  %s %s %s      ""%s""",0
ft5					db "%s%s",0
ft6					db "['P' _id: %d]%s",0
ft7					db "%lu   o%lu",0
ft8         db "%d,%d",0
combolcap		db "  R-click here:  monitoring  on/off",0
filter0			db "[Top-level]",0
filter1     db "[All]",0
filter4     db "[Root branch]",0
filter5     db "[In fixed point]",0
timerid			dd 1234
lf          LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Courier New">

.data?

hinst				HINSTANCE ?
hdlg				HWND ?
hwDesktop		HWND ?
hwMessage		HWND ?
hw_2001			HWND ?
hw_2002			HWND ?
hw_combo	 	HWND ?
hw_combol 	HWND ?
hW					HWND ?
hP					HWND ?
hX					HWND ?
hrgn				HRGN ?
hfont       HFONT ?
pid					dd ?
tid					dd ?
OldWndProc	dd ?
lp					dd ?
lp2					dd ?
create_count	dd ?	
win_count		dd ?
lck					dd ?
mon					dd ?
filter			dd ?
MinDlgWidth	dd ?
DlgHeight		dd ?
staticX			dd ?
staticY			dd ?
staticW			dd ?
staticH			dd ?
topwin			dd ?
point				POINT <>
styles			db 8 dup(?)
stylesP			db 8 dup(?)
buff0				db 1000h dup(?)
buff				db 1000h dup(?)
undo_stack	dd 12*64 dup(?)

.code

;########################################################################

RealChildWindowFromPoint_ proc hWnd:HWND,ptx:DWORD,pty:DWORD

  invoke GetModuleHandle,offset _user32
  invoke GetProcAddress,eax,offset _RealChildWindowFromPoint
  test eax,eax
  jz @f
  push pty
  push ptx
  push hWnd
  call eax
@@:
  ret
RealChildWindowFromPoint_ endp

;########################################################################

GetAncestor_ proc hWnd:HWND,ga:DWORD

  invoke GetModuleHandle,offset _user32
  invoke GetProcAddress,eax,offset _GetAncestor
  test eax,eax
  jz @f
  push ga
  push hWnd
  call eax
@@:
  ret
GetAncestor_ endp

;########################################################################

GetGaParent proc uses ebx hWnd:HWND ; GA_PARENT     ; - Win95:  instead of "GetAncestor,hWnd,GA_PARENT".
  mov ebx,hWnd
  invoke IsWindow,ebx
  .if eax==0 || ebx==hwDesktop || ebx==hwMessage
    xor eax,eax
    jmp @f
  .endif
  invoke GetWindowLong,ebx,GWL_HWNDPARENT
  mov ebx,eax
  invoke GetWindow,hWnd,GW_OWNER
  .if eax==0 && ebx!=0
    mov eax,ebx
  .else
    mov eax,hwDesktop
  .endif
@@:
  ret
GetGaParent endp

;########################################################################

GetGaRoot proc uses ebx hWnd:HWND  ; GA_ROOT
  mov ebx,hWnd
@@:
  invoke GetGaParent,ebx
  .if eax==0
    jmp @f
  .elseif eax==hwDesktop || eax==hwMessage
    mov eax,ebx
    jmp @f
  .else
    mov ebx,eax
    jmp @b
  .endif
@@:
  ret
GetGaRoot endp

;########################################################################

NewEdit proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	.if uMsg==WM_RBUTTONUP
		invoke DestroyWindow,hWnd
    xor eax,eax
	.elseif uMsg==WM_LBUTTONDOWN
    mov uMsg,WM_NCLBUTTONDOWN
    mov wParam,HTCAPTION
    jmp @f
	.else
@@:
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
	.endif
	ret
NewEdit endp

;########################################################################

NewCombol proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local buf[64]:BYTE
	local rt:RECT

	.if uMsg==WM_CLOSE
		mov eax,FALSE
		ret

	.elseif uMsg==WM_RBUTTONDOWN
		invoke SendMessage,hWnd,LB_ITEMFROMPOINT,0,lParam
		mov ebx,eax
		invoke SendMessage,hWnd,LB_SETCURSEL,ebx,0
		invoke SendMessage,hWnd,LB_GETITEMDATA,ebx,0
		mov hW,eax
		mov lck,1
		invoke CheckDlgButton,hdlg,2000,BST_CHECKED

	.elseif uMsg==WM_NCRBUTTONDOWN && wParam==HTCAPTION
		.if mon!=0
			mov mon,0
		.else
			invoke GetWindowRect,hWnd,addr rt
			mov eax,rt.bottom
			sub eax,rt.top
			mov mon,eax
		.endif
		invoke InvalidateRect,hWnd,0,1

	.elseif uMsg==WM_WINDOWPOSCHANGING
		.if mon!=0
			mov eax,lParam
			mov ecx,mon
			mov dword ptr [eax+5*4],ecx
			xor eax,eax
			ret
		.endif

	.endif
	invoke GetWindowLong,hWnd,GWL_USERDATA
	invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
	ret
NewCombol endp

;########################################################################

NewStatic proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local rt:RECT

	.if uMsg==WM_LBUTTONDOWN
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.elseif uMsg==WM_LBUTTONDBLCLK
		invoke SetWindowPos,hWnd,0,staticX,staticY,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_FRAMECHANGED

	.elseif uMsg==WM_WINDOWPOSCHANGING
		mov eax,lParam
		mov ecx,hw_2002
		mov dword ptr [eax+4],ecx
		mov edx,dword ptr [eax+2*4]
		mov ecx,staticX
		cmp edx,ecx
		jl @f
		mov dword ptr [eax+2*4],ecx
@@:
		mov ecx,staticY
		mov dword ptr [eax+3*4],ecx
		mov ecx,staticW
		mov dword ptr [eax+4*4],ecx
		mov ecx,staticH
		mov dword ptr [eax+5*4],ecx

	.else
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
		ret
	.endif
	mov eax,FALSE
	ret
NewStatic endp

;########################################################################

NewStatic2 proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_LBUTTONDOWN
		invoke SendMessage,hdlg,WM_LBUTTONDOWN,wParam,lParam
	.endif
	invoke GetWindowLong,hWnd,GWL_USERDATA
	invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
	ret
NewStatic2 endp

;########################################################################

EnCh proc hWnd:HWND, param:DWORD
	inc win_count
	mov ecx,hWnd
	xor eax,eax
	.if ecx!=param
		inc eax
	.endif
	ret
EnCh endp

;########################################################################

CreateToolhelp32Snapshot_ proc dwFlags:DWORD,th32ProcessID:DWORD
  invoke GetModuleHandle,offset _kernel32
  invoke GetProcAddress,eax,offset _CreateToolhelp32Snapshot
  test eax,eax
  jz @f
  push th32ProcessID
  push dwFlags
  call eax
@@:
  ret
CreateToolhelp32Snapshot_ endp

Process32First_ proc hSnapshot:DWORD,lppe:DWORD  ; HANDLE,LPPROCESSENTRY32
  invoke GetModuleHandle,offset _kernel32
  invoke GetProcAddress,eax,offset _Process32First
  test eax,eax
  jz @f
  push lppe
  push hSnapshot
  call eax
@@:
  ret
Process32First_ endp

Process32Next_ proc hSnapshot:DWORD,lppe:DWORD  ; HANDLE,LPPROCESSENTRY32
  invoke GetModuleHandle,offset _kernel32
  invoke GetProcAddress,eax,offset _Process32Next
  test eax,eax
  jz @f
  test eax,eax
  jz @f
  push lppe
  push hSnapshot
  call eax
@@:
  ret
Process32Next_ endp

;########################################################################

ProcessNameFromProcessID proc uses edi processID:DWORD,lpName:LPSTR
	local pe32:PROCESSENTRY32

	invoke CreateToolhelp32Snapshot_,TH32CS_SNAPPROCESS,processID
	test eax,eax
	jz @ret
	mov edi,eax  ; hSnapshot
	mov pe32.dwSize,sizeof pe32 
	invoke Process32First_,edi,addr pe32 
@@:
	test eax,eax
	jz @ret
	mov eax,processID
	cmp pe32.th32ProcessID,eax
	jz @f
	invoke Process32Next_,edi,addr pe32
	jmp @b
@@:
	invoke CloseHandle,edi
;
  lea eax,pe32.szExeFile
  mov byte ptr[eax+63],0
	invoke lstrcpy,lpName,eax
@ret:
  ret
ProcessNameFromProcessID endp

;########################################################################

Winfo proc uses ebx edi esi hWnd:HWND,lpbuff:DWORD
	local buf[512]:BYTE
	local buf1[64]:BYTE
	local buf2[64]:BYTE
	local buf3[64]:BYTE
	local mo[2]:BYTE
	local rt:RECT
	local pe32:PROCESSENTRY32
	local pid_:DWORD
	local tid_:DWORD
	local id_:DWORD

;	local idd[32]:BYTE

;	mov byte ptr [idd],0

	mov esi,hWnd
	invoke IsWindow,esi

	.if esi==HWND_MESSAGE ; -3
    invoke lstrcpy,addr buf,offset _HWND_MESS
    jmp @0
	.elseif eax==0 || esi==HWND_DESKTOP ; 0
		xor esi,esi
		mov word ptr [buf],0a0dh
		mov dword ptr [buf+2],[0][0]['0 ']
		jmp @0
	.endif

	xor eax,eax
	mov dword ptr[buf1],eax
	mov dword ptr[buf2],eax
	mov dword ptr[buf],eax
	mov ebx,offset styles
	mov	dword ptr [ebx],'___ '
	mov	dword ptr [ebx+4],[0]['-__']
	mov win_count,eax

;  invoke GetAncestor,hWnd,GA_ROOT
	invoke GetGaRoot,hWnd
	
;	 invoke GetAncestor,eax,GA_PARENT
  invoke GetGaParent,eax

	mov ecx,hwDesktop
	mov edx,hwMessage

	.if hWnd==ecx || eax==ecx
		mov word ptr [mo],[0][' ']
	.elseif hWnd==edx || eax==edx
		mov word ptr [mo],[0]['o']
	.endif

	.if hWnd!=ecx && hWnd!=edx
		invoke EnumChildWindows,eax,addr EnCh,hWnd
	.endif

	invoke GetClassName,hWnd,addr buf1,63
	invoke SendMessageTimeout,hWnd,WM_GETTEXT,63,addr buf2,SMTO_ABORTIFHUNG,300,0
	lea ecx,buf2
@@:
	mov al,byte ptr[ecx]
	test al,al
	jz @f
	.if al==13 || al==10
		mov byte ptr[ecx],32
	.endif
	inc ecx
	jmp @b
@@:
	invoke GetWindowLong,hWnd,GWL_ID
	mov id_,eax

	invoke GetWindowLong,hWnd,GWL_EXSTYLE
	push eax
	and eax,WS_EX_LAYERED
	.if eax!=0
		mov	byte ptr [ebx],'L'		  ; layered
	.endif
	pop eax
	and eax,WS_EX_TOPMOST
	.if eax!=0
		mov	byte ptr [ebx+1],'T'		; topmost
	.endif

	invoke GetWindowLong,hWnd,GWL_STYLE
	push eax
	mov ecx,eax
	and eax,WS_POPUP
	and ecx,WS_CHILD
	.if eax!=0 && ecx!=0
		mov	al,'X'									; WS_POPUP + WS_CHILD  ("impossible" case)
	.elseif eax!=0 && ecx==0
		mov	al,'P'									; WS_POPUP
	.elseif eax==0 && ecx!=0
		mov	al,'C'									; WS_CHILD
	.elseif eax==0 && ecx==0
		mov	al,'O'									; WS_OVERLAPPED (quasi!)
	.endif
	mov	byte ptr [ebx+2],al
	pop eax
	and eax,WS_CLIPCHILDREN				; WS_CLIPCHILDREN
	.if eax!=0
		mov	byte ptr [ebx+6],'+'
	.endif
	invoke IsIconic,hWnd
	.if eax!=0
		mov	byte ptr [ebx+3],'m'		; minimized
	.endif
	invoke IsZoomed,hWnd
	.if eax!=0
		mov	byte ptr [ebx+3],'M'		; maximized
	.endif
	invoke IsWindowVisible,hWnd
	.if eax!=0
		mov	al,'V'									; visible
	.else
		mov	al,'H'									; hidden
	.endif
	mov	byte ptr [ebx+4],al
	invoke IsWindowEnabled,hWnd
	.if eax!=0
		mov	al,'E'									; enabled
	.else
		mov	al,'D'									; disabled
	.endif
	mov	byte ptr [ebx+5],al

	invoke GetWindowThreadProcessId,hWnd,addr pid_
	mov tid_,eax

;	invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,pid_
;	mov edi,eax    ; hSnapshot
;	mov pe32.dwSize,sizeof pe32 
;	invoke Process32First,edi,addr pe32 
;@@:
;	test eax,eax
;	jz @err
;	mov eax,pid_
;	cmp pe32.th32ProcessID,eax
;	jz @f
;	invoke Process32Next,edi,addr pe32
;	jmp @b
;@@:
;	invoke CloseHandle,edi
;
;  lea eax,pe32.szExeFile
;  mov byte ptr[eax+63],0
;	invoke lstrcpy,addr buf3,eax
;	invoke PathStripPath,eax

  invoke ProcessNameFromProcessID,pid_,addr buf3
  test eax,eax
  jz @err
	invoke PathStripPath,addr buf
	jmp @f
@err:
	mov word ptr [buf3],[0]['?']			; "?",0
@@:
	invoke GetWindowRect,hWnd,addr rt
	mov ecx,rt.right
	sub ecx,rt.left
	mov edx,rt.bottom
	sub edx,rt.top
	mov ebx,id_
	and ebx,0ffffh
	invoke wsprintf,addr buf,offset ft,hWnd,addr mo,win_count,addr styles,ebx,tid_,addr buf1,rt.left,rt.top,ecx,edx,pid_,addr buf3,addr buf2
@0:
	invoke lstrcat,lpbuff,addr buf
	mov eax,esi
	ret
Winfo endp

;########################################################################

EnumThreadWindowsProc proc hWnd:HWND,param:DWORD
	local buf[64]:BYTE
	invoke GetClassName,hWnd,addr buf,63
	invoke lstrcmpi,addr buf,offset _combolbox
	.if eax==0
		mov ecx,hWnd
		mov hw_combol,ecx
	.endif
	ret
EnumThreadWindowsProc endp

;########################################################################

EnumChildWindowsProc proc uses ebx edi esi hWnd:HWND,param:DWORD
	local buf0[256]:BYTE
	local buf[256]:BYTE
	local buf1[64]:BYTE
	local buf2[64]:BYTE
	local buf3[64]:BYTE
	local buf4[2]:BYTE
	local lpid:DWORD
	local pt:POINT
	local rt:RECT

	mov word ptr [buf4],[0][' ']

	.if hWnd==HWND_DESKTOP
		mov edx,hwDesktop
		mov ecx,offset _HWND_DESK
		jmp @f
	.elseif hWnd==HWND_MESSAGE
		mov edx,hwMessage
		mov ecx,offset _HWND_MESS+3
@@:
		invoke lstrcpy,addr buf,ecx
	.else
		mov edx,hWnd
	.endif
	invoke GetWindowThreadProcessId,edx,addr lpid
	mov edi,eax																				; ltid
	xor esi,esi
	mov eax,hWnd
	lea ebx,buf1
	mov byte ptr [ebx],0
	.if eax==HWND_DESKTOP || eax==HWND_MESSAGE
		jmp @f
	.elseif eax==hwDesktop || eax==hwMessage
	.else
		.while (eax!=hwDesktop && eax!=hwMessage)
			mov byte ptr [ebx],'+'												; window tree
			inc ebx
			inc esi
			
;      invoke GetAncestor,eax,GA_PARENT ; - Win95
			invoke GetGaParent,eax
			
		.endw
		mov	byte ptr [ebx],[0]
		
;    invoke GetAncestor,hWnd,GA_PARENT ; - Win95
		invoke GetGaParent,hWnd
		
		invoke GetWindowThreadProcessId,eax,0
		.if eax==edi && esi==1
			mov al,'!'
		.elseif eax!=edi && esi==1
			mov al,'.'
		.elseif eax!=edi && esi!=1
			mov al,'?'
		.elseif eax==edi && esi!=1
			mov al,' '
		.endif
		mov byte ptr [buf1],al
	.endif

	.if esi==1 && topwin==0
		invoke GetWindowLong,hWnd,GWL_EXSTYLE
		and eax,WS_EX_TOPMOST
		.if eax==0
			inc topwin
			mov byte ptr [buf4],'='
		.endif
	.endif

	invoke GetClassName,hWnd,addr buf2,63
	invoke SendMessageTimeout,hWnd,WM_GETTEXT,63,addr buf3,SMTO_ABORTIFHUNG,300,0
	invoke wsprintf,addr buf,addr ft4,hWnd,addr buf4,addr buf1,addr buf2,addr buf3
@@:
	mov eax,lpid
	.if filter==0 && esi>1														; all top-level windows (+ message-only)
		jmp @f

	.elseif filter==5             										; all following windows: cursor over WindowRect
		invoke GetWindowRect,hWnd,addr rt
		invoke PtInRect,addr rt,point.x,point.y
		test eax,eax
		jz @f
		invoke GetWindowRgn,hWnd,hrgn
		.if eax==NULLREGION
			jmp @f

		.elseif eax==SIMPLEREGION || eax==COMPLEXREGION
			mov eax,point.x
			sub eax,rt.left
			mov ecx,point.y
			sub ecx,rt.top
			invoke PtInRegion,hrgn,eax,ecx
			.if eax==0
				jmp @f
			.endif
		.endif

	.elseif filter==1             										; all windows (+ message-only)
	.elseif filter==4		              								; root branch of window tree
	.elseif filter==2 && eax!=pid											; all PID windows (+ message-only)
		jmp @f
	.elseif filter==3 && edi!=tid											; all TID windows (+ message-only)
		jmp @f
	.endif
	mov ebx,win_count
	inc win_count
	.if param==0
		invoke SendMessage,hw_combo,CB_GETLBTEXT,ebx,addr buf0
		invoke lstrcmp,addr buf0,addr buf
		.if eax!=0
			xor eax,eax
			mov win_count,eax
		.else
			inc eax
		.endif
		ret
	.else
		invoke SendMessage,hw_combo,CB_ADDSTRING,0,addr buf
		invoke SendMessage,hw_combo,CB_SETITEMDATA,ebx,hWnd
		mov eax,hWnd
		.if eax==hP
			invoke SendMessage,hw_combo,CB_SETCURSEL,ebx,0
		.endif
	.endif
@@:
	xor eax,eax
	inc eax
	ret
EnumChildWindowsProc endp

;########################################################################

; EnumWindowsProc proc uses ebx edi esi hWnd:HWND,param:LPARAM
; 	local buf0[256]:BYTE
; 	local buf[256]:BYTE
; 	local buf1[64]:BYTE
; 	local buf2[64]:BYTE
; 	local buf3[64]:BYTE
; 	local buf4[2]:BYTE
; 
; 	mov word ptr [buf1],[0]['.']
; 	invoke GetClassName,hWnd,addr buf2,63
; 	invoke SendMessageTimeout,hWnd,WM_GETTEXT,63,addr buf3,SMTO_ABORTIFHUNG,300,0
; 	mov word ptr [buf4],[0][' ']	
; 	invoke wsprintf,addr buf,addr ft4,hWnd,addr buf4,addr buf1,addr buf2,addr buf3
; 
; 	mov ebx,win_count
; 	inc win_count
; 	.if param==0
; 		invoke SendMessage,hw_combo,CB_GETLBTEXT,ebx,addr buf0
; 		invoke lstrcmp,addr buf0,addr buf
; 		.if eax!=0
; 			xor eax,eax
; 			mov win_count,eax
; 		.else
; 			inc eax
; 		.endif
; 		ret
; 	.else
; 		invoke SendMessage,hw_combo,CB_ADDSTRING,0,addr buf
; 		invoke SendMessage,hw_combo,CB_SETITEMDATA,ebx,hWnd
; 		mov eax,hWnd
; 		.if eax==hP
; 			invoke SendMessage,hw_combo,CB_SETCURSEL,ebx,0
; 		.endif
; 	.endif
; @@:
; 	xor eax,eax
; 	inc eax
; 	ret
; EnumWindowsProc endp

;########################################################################

; PARENTOWNER struct
; 	hWnd        DWORD ?		; 0
; 	hWndParent 	DWORD ?		; 1
; 	ClientRect  RECT <>		; 2,3,4,5
; 	Exstyle     DWORD ?		; 6
; 	Style       DWORD ?		; 7
;   FncParam		DWORD ?		; 8
; 	hPrntOwner 	DWORD ?		; 9
;   Id					DWORD ?		; 10
;		reserve			DWORD ?   ; 11
; PARENTOWNER ends

UndoRedo proc uses ebx edi esi param:DWORD
	local rt:RECT
	local hparent:HWND
	local style:DWORD
	local exstyle:DWORD
	local retval:DWORD
	local id:DWORD

	mov eax,param
	sub lp,eax
	mov ebx,lp
	mov eax,ebx
	shl ebx,1
	add ebx,eax
	shl ebx,4																		; lp*4*4*3  
	add ebx,offset undo_stack

	mov edi,dword ptr [ebx]											; ? hW
	mov esi,dword ptr [ebx+9*4]									; ? hPO

	invoke GetWindowLong,edi,GWL_ID
	mov id,eax
	invoke GetWindowLong,edi,GWL_EXSTYLE
	mov exstyle,eax
	invoke GetWindowLong,edi,GWL_STYLE
	mov style,eax
	
;  invoke GetAncestor,edi,GA_PARENT ; - Win95
  invoke GetGaParent,edi
	
	mov hparent,eax
	invoke GetWindowRect,edi,addr rt
	invoke MapWindowPoints,0,hparent,addr rt,2

	mov eax,dword ptr [ebx+8*4]
	.if eax==0
		invoke SetParent,edi,esi
		test eax,eax
		jnz @f
	.else
		invoke SetLastError,0
		invoke SetWindowLong,edi,GWL_HWNDPARENT,esi
		test eax,eax
		jnz @f
		invoke GetLastError
		test eax,eax
		jz @f
	.endif
	jmp @err
@@:
	mov retval,eax

;	invoke GetAncestor,edi,GA_PARENT ; - Win95
  invoke GetGaParent,edi

	mov ecx,dword ptr [ebx+4]										; ? hP
	.if ecx==0
		mov ecx,hwDesktop
	.endif

	.if eax!=ecx
		mov eax,dword ptr [ebx+8*4]
		.if eax==0
			invoke SetParent,edi,retval
		.else
			invoke SetWindowLong,edi,GWL_HWNDPARENT,retval
		.endif
@err:
		invoke MessageBeep,MB_ICONHAND
		jmp @@@
	.endif

	mov hW,edi

	mov eax,hparent
	mov dword ptr [ebx+4],eax
	mov hparent,ecx

	mov eax,dword ptr [ebx+6*4]
	invoke SetWindowLong,hW,GWL_EXSTYLE,eax
	mov eax,exstyle
	mov dword ptr [ebx+6*4],eax

	mov eax,dword ptr [ebx+7*4]
	invoke SetWindowLong,hW,GWL_STYLE,eax
	mov eax,style
	mov dword ptr [ebx+7*4],eax

	mov eax,retval
	mov dword ptr [ebx+9*4],eax

	mov eax,dword ptr [ebx+10*4]
	invoke SetWindowLong,hW,GWL_ID,eax
	mov eax,id
	mov dword ptr [ebx+10*4],eax

	push SWP_NOZORDER OR SWP_FRAMECHANGED
	mov eax,dword ptr [ebx+5*4]
	mov ecx,dword ptr [ebx+3*4]
	sub eax,ecx
	push eax
	mov eax,dword ptr [ebx+4*4]
	mov edx,dword ptr [ebx+2*4]
	sub eax,edx
	push eax
	push ecx
	push edx
	push 0
	push edi
	call SetWindowPos

	mov eax,rt.left
	mov dword ptr [ebx +2*4],eax
	mov eax,rt.top
	mov dword ptr [ebx +3*4],eax
	mov eax,rt.right
	mov dword ptr [ebx +4*4],eax
	mov eax,rt.bottom
	mov dword ptr [ebx +5*4],eax

;	invoke InvalidateRect,hW,0,1
;	invoke RedrawWindow,hW,0,0,RDW_ERASE OR RDW_INVALIDATE OR RDW_ALLCHILDREN

	invoke IsWindowVisible,hW
	.if eax!=0
		invoke ShowWindow,hW,SW_HIDE
		invoke ShowWindow,hW,SW_SHOWNORMAL
	.endif

@@@:
	mov eax,param
	dec eax
	sub lp,eax
	invoke SetDlgItemInt,hdlg,2006,lp,0
	ret
UndoRedo endp

;########################################################################

FullUndo proc
	.while lp>0
		invoke UndoRedo,1	; Undo
	.endw
	xor eax,eax
	mov lp2,eax
	ret
FullUndo endp

;########################################################################

OwnerInfo proc uses ebx hWnd:HWND
	local buf[256]:BYTE
	local buf1[64]:BYTE
	local buf2[64]:BYTE

	invoke GetWindow,hWnd,GW_OWNER
	mov ebx,eax
	.if ebx!=0
		invoke GetClassName,ebx,addr buf1,63
		invoke SendMessageTimeout,ebx,WM_GETTEXT,63,addr buf2,SMTO_ABORTIFHUNG,300,0
		invoke wsprintf,addr buf,offset ft3,offset _Owner,ebx,addr buf1,addr buf2
	.else
		invoke lstrcpy,addr buf,offset _Owner
	.endif
	invoke SendDlgItemMessage,hWnd,201,WM_SETTEXT,0,addr buf
	ret
OwnerInfo endp

;########################################################################

StyleTrigger proc hWnd:HWND,style:DWORD  ; (style - one bit only)
	invoke GetWindowLong,hWnd,GWL_STYLE
  xor eax,style
	invoke SetWindowLong,hWnd,GWL_STYLE,eax
	invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
	invoke InvalidateRect,hWnd,0,1
	ret
StyleTrigger endp

;########################################################################

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM, lParam:LPARAM
	local buf[64]:BYTE

	.if uMsg==WM_CREATE
		mov eax,hWnd
		mov hW,eax
		mov lck,1
		invoke CheckDlgButton,hdlg,2000,BST_CHECKED
		inc create_count
		invoke wsprintf,addr buf,offset ft2,hWnd,create_count
		invoke SendMessage,hWnd,WM_SETTEXT,0,addr buf

	.elseif uMsg==WM_WINDOWPOSCHANGED
		invoke OwnerInfo,hWnd

	.elseif uMsg==WM_COMMAND && wParam==202
		invoke StyleTrigger,hWnd,WS_POPUP

	.elseif uMsg==WM_STYLECHANGED
		invoke GetWindowLong,hWnd,GWL_STYLE
		mov ecx,offset _Overlapped
		test eax,WS_POPUP
		jz @f
		mov ecx,offset _Popup
@@:
		invoke SendDlgItemMessage,hWnd,202,WM_SETTEXT,0,ecx

	.elseif uMsg==WM_LBUTTONDOWN
    mov uMsg,WM_NCLBUTTONDOWN
    mov wParam,HTCAPTION
    jmp @f
	.else
@@:
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		jmp @f
	.endif
	xor eax,eax
@@:
	ret
WndProc endp

;########################################################################  WM_CTLCOLORSTATIC

DlgProc2 proc hWnd:HWND,uMsg:UINT,wParam:WPARAM, lParam:LPARAM
	local buf[64]:BYTE

	.if uMsg==WM_INITDIALOG
		mov eax,hWnd
		mov hW,eax
		mov lck,1
		invoke CheckDlgButton,hdlg,2000,BST_CHECKED
		inc create_count
		invoke SetWindowLong,hWnd,GWL_USERDATA,lParam
		.if lParam==0
			mov edx,offset _Modal
		.else
			mov edx,offset _Modeless
		.endif
		invoke wsprintf,addr buf,offset ft1,hWnd,edx,create_count
		invoke SendMessage,hWnd,WM_SETTEXT,0,addr buf
		jmp @f

	.elseif uMsg==WM_WINDOWPOSCHANGED
@@:
		invoke OwnerInfo,hWnd

	.elseif uMsg==WM_CLOSE
		invoke GetWindowLong,hWnd,GWL_USERDATA
		.if eax==0
			invoke EndDialog,hWnd,0
		.else
			invoke DestroyWindow,hWnd
		.endif

	.elseif uMsg==WM_LBUTTONDOWN
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.elseif uMsg==WM_COMMAND && wParam==202
		invoke StyleTrigger,hWnd,WS_POPUP

	.elseif uMsg==WM_STYLECHANGED
		invoke GetWindowLong,hWnd,GWL_STYLE
		mov ecx,offset _Overlapped
		test eax,WS_POPUP
		jz @f
		mov ecx,offset _Popup
@@:
		invoke SendDlgItemMessage,hWnd,202,WM_SETTEXT,0,ecx

	.else
		mov eax,FALSE
		ret

	.endif
	mov eax,TRUE
	ret
DlgProc2 endp

;########################################################################

CombolCaption proc

	local buf[256]:BYTE
	
;	mov byte ptr[buf],0

	.if filter==0
		mov eax,offset filter0
		jmp @f
	.elseif filter==1
		mov eax,offset filter1
		jmp @f
	.elseif filter==4
		mov eax,offset filter4
		jmp @f
	.elseif filter==5
		mov eax,offset filter5
@@:
		invoke wsprintf,addr buf,offset ft5,eax,offset combolcap
	.elseif filter==2
		mov al,'p'
		mov ecx,pid
		jmp @f
	.elseif filter==3
		mov al,'t'
		mov ecx,tid
@@:
		mov byte ptr [ft6+5],al
		invoke wsprintf,addr buf,offset ft6,ecx,offset combolcap
	.endif
	invoke SendMessage,hw_combol,WM_SETTEXT,0,addr buf
	ret
CombolCaption endp

;########################################################################

FillCombo proc uses ebx
	local buf[64]:BYTE
	local buf2[64]:BYTE

	.if hX==HWND_DESKTOP
		mov ebx,hwDesktop
	.elseif hX==HWND_MESSAGE
		mov ebx,hwMessage
	.else
		invoke IsWindow,hX
		.if eax==0
		  xor ebx,ebx
		  mov hX,ebx
		.else
		  mov ebx,hX
		.endif
	.endif

	invoke GetWindowThreadProcessId,ebx,addr pid
	mov tid,eax

	mov win_count,0

;  .if filter==-1
;    invoke EnumWindows,addr EnumWindowsProc,1
;  .elseif filter==4  ; Branch

  .if filter==4  ; Branch
    
    .if ebx!=hwMessage
;      invoke GetAncestor,ebx,GA_ROOT
      invoke GetGaRoot,ebx
      mov ebx,eax
;      invoke GetAncestor,ebx,GA_PARENT
      invoke GetGaParent,ebx
      
      .if eax==hwMessage
        mov ebx,eax
      .endif
	  .endif

		invoke EnumChildWindowsProc,ebx,0
		invoke EnumChildWindows,ebx,addr EnumChildWindowsProc,0
		mov eax,win_count
		test eax,eax
		jz @f
		ret
@@:
		invoke SendMessage,hw_combo,CB_RESETCONTENT,0,0
		invoke EnumChildWindowsProc,ebx,1
		invoke EnumChildWindows,ebx,addr EnumChildWindowsProc,1
		invoke wsprintf,addr buf,offset ft7+7,win_count
	.else
		mov topwin,0
		invoke EnumChildWindowsProc,HWND_DESKTOP,0
		invoke EnumChildWindowsProc,hwDesktop,0
		invoke EnumChildWindows,hwDesktop,addr EnumChildWindowsProc,0
		mov eax,win_count
		test eax,eax
		jz @f
		invoke EnumChildWindowsProc,HWND_MESSAGE,0
		invoke EnumChildWindowsProc,hwMessage,0
		invoke EnumChildWindows,hwMessage,addr EnumChildWindowsProc,0
		mov eax,win_count
		test eax,eax
		jz @f
		ret
@@:
		mov topwin,0
		invoke SendMessage,hw_combo,CB_RESETCONTENT,0,0
		invoke EnumChildWindowsProc,HWND_DESKTOP,1
		invoke EnumChildWindowsProc,hwDesktop,1
		invoke EnumChildWindows,hwDesktop,addr EnumChildWindowsProc,1
		mov ebx,win_count
		invoke EnumChildWindowsProc,HWND_MESSAGE,1
		invoke EnumChildWindowsProc,hwMessage,1
		invoke EnumChildWindows,hwMessage,addr EnumChildWindowsProc,1
		mov ecx,win_count
		sub ecx,ebx
		invoke wsprintf,addr buf,offset ft7,ebx,ecx		
	.endif

	invoke GetDlgItemText,hdlg,2026,addr buf2,63
	invoke lstrcmp,addr buf,addr buf2
	.if eax!=0
		invoke SetDlgItemText,hdlg,2026,addr buf
	.endif
	ret
FillCombo endp

;########################################################################

OnInitDialog proc uses ebx hWnd:HWND

  local rt:RECT
	local wc:WNDCLASSEX  
  
  push hWnd
	pop hdlg
	xor eax,eax
	mov dword ptr[buff0],eax
	mov hW,eax
	mov hP,eax

	invoke SendDlgItemMessage,hWnd,2002,WM_SETTEXT,0,offset text
	invoke SendMessage,hWnd,WM_SETTEXT,0,offset help
	invoke lstrlen,offset help
	mov byte ptr[help+eax],' '

	invoke GetDlgItem,hWnd,2001
	mov hw_2001,eax
	invoke SetWindowLong,hw_2001,GWL_WNDPROC,offset NewStatic
	invoke SetWindowLong,hw_2001,GWL_USERDATA,eax

	invoke GetDlgItem,hWnd,2002
	mov hw_2002,eax
	invoke SetWindowLong,hw_2002,GWL_WNDPROC,offset NewStatic2
	invoke SetWindowLong,hw_2002,GWL_USERDATA,eax

	invoke GetDlgItem,hdlg,2016
	mov hw_combo,eax
;		mov cbi.cbSize,sizeof cbi
;		invoke GetComboBoxInfo,hw_combo,addr cbi
;		push cbi.hwndList
;		pop hw_combol
	invoke GetWindowThreadProcessId,hWnd,0
;  invoke GetCurrentThreadId
	invoke EnumThreadWindows,eax,offset EnumThreadWindowsProc,0
	invoke SetWindowLong,hw_combol,GWL_WNDPROC,offset NewCombol
	invoke SetWindowLong,hw_combol,GWL_USERDATA,eax
	invoke SetWindowPos,hw_combol,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE OR SWP_NOMOVE OR SWP_FRAMECHANGED
	invoke SetWindowLong,hw_combol,GWL_HWNDPARENT,hWnd ; 
	invoke CombolCaption

	invoke GetWindowRect,hWnd,addr rt
	mov eax,rt.right
	sub eax,rt.left
	mov MinDlgWidth,eax
	mov eax,rt.bottom
	sub eax,rt.top
	mov DlgHeight,eax

	invoke GetWindowRect,hw_2001,addr rt
	invoke MapWindowPoints,0,hWnd,addr rt,2
	mov eax,rt.top
	mov staticY,eax
	mov eax,rt.left
	mov staticX,eax
	mov eax,rt.bottom
	sub eax,rt.top
	mov staticH,eax
	invoke GetSystemMetrics,SM_CXSCREEN
	add eax,eax
	mov staticW,eax
	invoke SetWindowPos,hw_2001,0,0,0,staticW,staticH,SWP_NOZORDER OR SWP_NOMOVE OR SWP_FRAMECHANGED

	invoke GetSystemMenu,hWnd,0
	mov ebx,eax
	invoke AppendMenu,ebx,MF_SEPARATOR,0,0
	invoke AppendMenu,ebx,MF_STRING,idm_help,offset hlp

	mov wc.cbSize,sizeof WNDCLASSEX
	mov eax,hinst
	mov wc.hInstance,eax
	mov wc.style,CS_DBLCLKS	
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov wc.lpfnWndProc,offset WndProc
	mov wc.hbrBackground,COLOR_WINDOW
	mov wc.lpszMenuName,300
	invoke	LoadIcon,0,IDI_APPLICATION
	mov wc.hIcon,eax
	mov wc.hIconSm,0	
	invoke LoadCursor,0,IDC_ARROW
	mov	wc.hCursor,eax
	mov wc.lpszClassName,offset _wndclass
	invoke RegisterClassEx,addr wc

;--- anti HideToolz by Ms-Rem ----------------------
;
  invoke SetParent,hWnd,HWND_MESSAGE ; -3  ; instead of FindWindowEx
  test eax,eax  ; ? WinOS>=Win98 ?
  jz @f
	mov hwDesktop,eax
	
;  invoke GetAncestor,hWnd,GA_PARENT
;  invoke GetWindowLong,hWnd,GWL_HWNDPARENT
  invoke GetGaParent,hWnd
  
  push eax
  invoke SetParent,hWnd,HWND_DESKTOP ; 0
  pop eax
@@:
  mov hwMessage,eax
;
;--- instead of ------------------------------------
;
;	invoke FindWindowEx,HWND_MESSAGE,0,0,0  ; (HideToolz "cancels", in particular, FindWindowEx)  ; unworkable for Win98,WinME
;	test eax,eax
;	jz @f

;;	invoke GetAncestor,eax,GA_PARENT
; invoke GetWindowLong,eax,GWL_HWNDPARENT

;@@:
; mov hwMessage,eax
;	invoke GetDesktopWindow
;	mov hwDesktop,eax
;
;---------------------------------------------------

	invoke SendDlgItemMessage,hWnd,2007,BM_CLICK,0,0
	invoke SendDlgItemMessage,hWnd,2027,BM_CLICK,0,0	

	invoke CreateRectRgn,0,0,0,0
	mov hrgn,eax

  invoke CreateFontIndirect,offset lf
  mov hfont,eax
  invoke SendDlgItemMessage,hWnd,2001,WM_SETFONT,hfont,1
  invoke SendDlgItemMessage,hWnd,2002,WM_SETFONT,hfont,1
;  invoke CheckDlgButton,hWnd,2027,BST_CHECKED  
	invoke SetTimer,hWnd,timerid,100,0
  ret
OnInitDialog endp

;########################################################################

OnTimer proc uses ebx edi esi hWnd:HWND

  local pt:POINT
  local buf[32]:BYTE
  local buf0[32]:BYTE

	invoke SendDlgItemMessage,hWnd,2038,WM_GETTEXT,1,addr buf
	mov bl,byte ptr buf
  invoke IsDlgButtonChecked,hWnd,2038  ;  set hX=hW or hX=hP
  xor edx,edx
  .if eax!=0
    mov ecx,hW
    mov dl,'W'
  .else
    mov ecx,hP
    mov dl,'P'
  .endif
  mov hX,ecx
  .if dl!=bl
    mov word ptr buf,dx
		invoke SendDlgItemMessage,hWnd,2038,WM_SETTEXT,0,addr buf
  .endif

	invoke GetCursorPos,addr pt
	
  invoke wsprintf,addr buf,offset ft8,pt.x,pt.y
  invoke GetDlgItemText,hWnd,2047,31,addr buf0
  invoke lstrcmpi,addr buf0,addr buf
  .if eax!=0
    invoke SetDlgItemText,hWnd,2047,addr buf
  .endif

  invoke wsprintf,addr buf,offset ft8,point.x,point.y
  invoke GetDlgItemText,hWnd,2040,31,addr buf0
  invoke lstrcmpi,addr buf0,addr buf
  .if eax!=0
    invoke SetDlgItemText,hWnd,2040,addr buf
  .endif
	
	invoke IsDlgButtonChecked,hWnd,2028
	mov esi,eax

  .if esi==0
    mov edi,offset _hwnd3
  .else
    mov edi,offset _hwnd1
  .endif
  invoke GetDlgItemText,hWnd,2028,31,addr buf
  invoke lstrcmpi,addr buf,edi
  .if eax!=0
    invoke SetDlgItemText,hWnd,2028,edi
  .endif

	mov ebx,hwDesktop
	mov ecx,ebx
@@:
	invoke MapWindowPoints,ecx,ebx,addr pt,1
  .if esi==0                                                        ; 'hwnd.3'
    invoke ChildWindowFromPointEx,ebx,pt.x,pt.y,CWP_SKIPINVISIBLE
  .else                                                             ; 'hwnd.1'
    invoke RealChildWindowFromPoint_,ebx,pt.x,pt.y
  .endif
	.if eax!=0 && eax!=ebx
		mov ecx,ebx
		mov ebx,eax
		jmp @b
	.endif

	invoke GetAsyncKeyState,VK_F9
	and ax,8000h
	.if ax!=0
		mov hP,ebx
		invoke GetCursorPos,offset point
	.endif
	invoke GetAsyncKeyState,VK_F8
	and ax,8000h
	.if ax!=0 && lck==0
		mov lck,eax
		invoke CheckDlgButton,hWnd,2000,eax
		mov hW,ebx
	.elseif lck!=0
		mov ebx,hW
	.endif

  mov edi,offset buff  
	invoke lstrcpy,edi,offset head
	invoke Winfo,ebx,edi
	invoke Winfo,hP,edi
	mov hP,eax
	mov eax,dword ptr[styles]
	mov dword ptr[stylesP],eax
	mov eax,dword ptr[styles+4]
	mov dword ptr[stylesP+4],eax
	invoke lstrcat,edi,offset _line

	mov esi,ebx
	.if ebx==hwMessage  ; (for XP-pro-sp2)
;    xor ebx,ebx
  .endif

	invoke GetWindow,ebx,GW_OWNER
	invoke Winfo,eax,edi
;	xchg esi,ebx
	invoke GetWindowLong,ebx,GWL_HWNDPARENT
	invoke Winfo,eax,edi
	invoke GetParent,ebx
	invoke Winfo,eax,edi
	invoke GetAncestor_,ebx,GA_PARENT ; - Win95
	invoke Winfo,eax,edi	
	invoke GetGaParent,ebx
	invoke Winfo,eax,edi
	invoke GetGaRoot,ebx
	invoke Winfo,eax,edi
	invoke GetAncestor_,ebx,GA_ROOT ; - Win95
	invoke Winfo,eax,edi
	invoke GetAncestor_,ebx,GA_ROOTOWNER ; - Win95
	invoke Winfo,eax,edi
	invoke GetWindow,hP,GW_ENABLEDPOPUP
	.if eax==hP
		xor eax,eax
	.endif
	invoke Winfo,eax,edi
	invoke GetLastActivePopup,hP
	.if eax==hP
		xor eax,eax
	.endif
	invoke Winfo,eax,edi
;	invoke lstrcat,edi,offset _line
  invoke GetWindow,ebx,GW_CHILD
	invoke Winfo,eax,edi
;	xchg esi,ebx
  invoke GetWindow,ebx,GW_HWNDNEXT
	invoke Winfo,eax,edi
  invoke GetWindow,ebx,GW_HWNDPREV
	invoke Winfo,eax,edi
  invoke GetWindow,ebx,GW_HWNDLAST
	invoke Winfo,eax,edi	
  invoke GetWindow,ebx,GW_HWNDFIRST  
	invoke Winfo,eax,edi
;	invoke lstrcat,edi,offset _line
	invoke lstrcmp,addr buff0,edi
	.if eax!=0
		invoke lstrcpy,addr buff0,edi
		invoke SendDlgItemMessage,hWnd,2001,WM_SETTEXT,0,edi
	.endif

	invoke IsWindowVisible,hw_combol
	.if eax==0
		mov mon,eax
		invoke GetWindowLong,hw_combol,GWL_STYLE
		mov ecx,eax
		and eax,not (WS_CAPTION or WS_THICKFRAME or WS_POPUP)
		or eax,WS_BORDER
		.if eax!=ecx
			invoke SetWindowLong,hw_combol,GWL_STYLE,eax
			invoke SetWindowPos,hw_combol,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
		.endif
	.else
		.if mon!=0
			invoke FillCombo
		.endif
	.endif
	ret
OnTimer endp

;########################################################################

OnCommand proc uses ebx edi esi hWnd:HWND, wParam:WPARAM, lParam:LPARAM

	local pt:POINT
	local rt:RECT
	local buf[256]:BYTE
	local style:DWORD
	local exstyle:DWORD
	local id:DWORD
	local cid:DWORD

  mov edx,wParam
  mov ecx,edx
  shr ecx,16
;-----------------------------------------------------------------------------
  .if ecx==CBN_SELCHANGE
  	invoke SendMessage,hw_combo,CB_GETCURSEL,0,0
  	invoke SendMessage,hw_combo,CB_GETITEMDATA,eax,0
  	mov hP,eax
;-----------------------------------------------------------------------------
  .elseif ecx==CBN_DROPDOWN
  	invoke FillCombo
;-----------------------------------------------------------------------------
  .elseif edx==2027
  	invoke IsDlgButtonChecked,hWnd,2027
  	.if eax!=BST_UNCHECKED
	    invoke SetTimer,hWnd,timerid,100,0
	  .endif
;-----------------------------------------------------------------------------
;  .elseif edx==2028
;  	invoke IsDlgButtonChecked,hWnd,2028
;  	.if eax==0
;  	  mov eax,offset _hwnd3
;  	.else
;  	  mov eax,offset _hwnd1
;  	.endif
;  	invoke SetDlgItemText,hWnd,2028,eax
;-----------------------------------------------------------------------------
  .elseif edx==2000
  	invoke IsDlgButtonChecked,hWnd,2000
  	mov lck,eax
;-----------------------------------------------------------------------------
  .elseif edx==2003 || edx==2020							; SetParent / <SetOwner> = SetWindowLong(GWL_HWNDPARENT)
  	.if lp>=63 || lck==0
  		jmp @beep
  	.endif
  
  	invoke GetWindowLong,hW,GWL_EXSTYLE
  	mov exstyle,eax
  	invoke GetWindowLong,hW,GWL_STYLE
  	mov style,eax
  	invoke GetWindowLong,hW,GWL_ID
  	mov id,eax
  	invoke GetWindowRect,hW,addr rt
  	
;  	invoke GetAncestor,hW,GA_PARENT ; - Win95
   invoke GetGaParent,hW
   
  	mov esi,eax
  	invoke MapWindowPoints,0,esi,addr rt,2
  
  	xor edi,edi
  	.if wParam==2003
  		invoke SetParent,hW,hP
  		test eax,eax
  		jnz @f
  	.else
  		inc edi
  		invoke SetLastError,0
  		invoke SetWindowLong,hW,GWL_HWNDPARENT,hP			; at your own risk :-)
  		test eax,eax
  		jnz @f
  		invoke GetLastError
  		test eax,eax
  		jz @f
  	.endif
  	invoke MessageBeep,MB_ICONHAND
  	jmp @@@@
@@:
    mov ebx,lp
    mov ecx,ebx
    shl ebx,1
    add ebx,ecx
    shl ebx,4																	; lp*4*4*3  
    mov edx,offset undo_stack
    
    add ebx,edx
    mov edx,hW
    mov dword ptr [ebx],edx
    mov dword ptr [ebx +4],esi
    mov dword ptr [ebx +9*4],eax
    
    mov eax,rt.left
    mov dword ptr [ebx +2*4],eax
    mov eax,rt.top
    mov dword ptr [ebx +3*4],eax
    mov eax,rt.right
    mov dword ptr [ebx +4*4],eax
    mov eax,rt.bottom
    mov dword ptr [ebx +5*4],eax
    
    mov eax,exstyle
    mov dword ptr [ebx +6*4],eax
    mov eax,style
    mov dword ptr [ebx +7*4],eax
    
    mov dword ptr [ebx +8*4],edi
    
    mov eax,id
    mov dword ptr [ebx +10*4],eax
    
    inc lp
    mov eax,lp
    .if lp2<eax
    	mov lp2,eax
    .endif
    
;    invoke GetAncestor,hW,GA_PARENT ; - Win95
    invoke GetGaParent,hW
    
    mov esi,eax
    mov eax,point.x
    mov pt.x,eax
    mov eax,point.y
    mov pt.y,eax
    invoke MapWindowPoints,0,esi,addr pt,1
    invoke SetWindowPos,hW,0,pt.x,pt.y,0,0,SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOZORDER

;    invoke InvalidateRect,hW,0,1
;    invoke RedrawWindow,hW,0,0,RDW_ERASE OR RDW_INVALIDATE OR RDW_ALLCHILDREN

    invoke IsWindowVisible,hW
    .if eax!=0
    	invoke ShowWindow,hW,SW_HIDE
    	invoke ShowWindow,hW,SW_SHOWNORMAL
    .endif

@@@@:
    invoke SetDlgItemInt,hdlg,2006,lp,0
;-----------------------------------------------------------------------------
  .elseif edx==2004
  	.if lp>0
  		invoke UndoRedo,1 												; Undo
  	.else
  		jmp @beep
  	.endif
;-----------------------------------------------------------------------------
  .elseif edx==2005
  	mov eax,lp2
  	.if eax>lp && eax<64
  		invoke UndoRedo,0 												; Redo
  	.else
@beep:
    	invoke MessageBeep,MB_ICONHAND
    .endif
;-----------------------------------------------------------------------------
  .elseif edx==2006
  	invoke FullUndo															; Full Undo
;-----------------------------------------------------------------------------
  .elseif edx==2013
;  	invoke CreateDialogParam,hinst,offset DlgName3,hX,0,0
    invoke CreateWindowEx,\
      0,\
      offset _wndclass,0,\
      WS_VISIBLE or WS_POPUP or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_THICKFRAME or WS_CLIPCHILDREN,\
      0,0,308,160,hX,0,hinst,0
    mov ebx,eax
    invoke SendMessage,hWnd,WM_GETFONT,0,0
    mov edi,eax
    invoke CreateWindowEx,0,offset _static,0,WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS,6,26,600,23,ebx,201,hinst,0
    invoke SendMessage,eax,WM_SETFONT,edi,0
    invoke CreateWindowEx,0,offset _button,offset _btntxt,WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or BS_FLAT,76,68,150,23,ebx,202,hinst,0
    invoke SendMessage,eax,WM_SETFONT,edi,TRUE
  	invoke OwnerInfo,ebx
;-----------------------------------------------------------------------------
  .elseif edx==2021
  	invoke CreateDialogParam,hinst,addr DlgName2,hX,offset DlgProc2,1
;-----------------------------------------------------------------------------
  .elseif edx==2022
  	invoke DialogBoxParam,hinst,addr DlgName2,hX,offset DlgProc2,0
;-----------------------------------------------------------------------------
  .elseif edx==2036
  	invoke MessageBox,hX,offset _mb,offset _mb,MB_SYSTEMMODAL
;-----------------------------------------------------------------------------
  .elseif edx==2017
  	invoke SendMessage,hw_combo,WM_GETTEXT,255,addr buf
  	invoke SendMessageTimeout,hX,WM_SETTEXT,0,addr buf,SMTO_ABORTIFHUNG,300,0
;-----------------------------------------------------------------------------
  .elseif edx==2029
  	invoke GetDlgItemInt,hWnd,2016,addr cid,0	; combobox
  	.if cid!=0
  		invoke SetWindowLong,hX,GWL_ID,eax
  		invoke SetWindowPos,hX,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
  		invoke InvalidateRect,hX,0,1
  	.else
  		jmp @beep
  	.endif
;-----------------------------------------------------------------------------
  .elseif edx==2018
  	invoke PostMessage,hX,WM_CLOSE,0,0
;  	invoke PostMessage,hX,WM_DESTROY,0,0
;-----------------------------------------------------------------------------
  .elseif edx==2015													;  sWaP			( Window <--> Parent|Owner )
  	.if lck==0
  		jmp @beep
  	.endif
  	mov eax,hP
  	mov ecx,hW
  	mov hW,eax
  	mov hP,ecx
;-----------------------------------------------------------------------------
  .elseif edx==2008
  	mov eax,HWND_TOPMOST
  	mov ecx,SWP_NOSIZE OR SWP_NOMOVE OR SWP_FRAMECHANGED
  	jmp @f
  .elseif edx==2041
  	mov eax,HWND_NOTOPMOST
  	mov ecx,SWP_NOSIZE OR SWP_NOMOVE OR SWP_FRAMECHANGED
  	jmp @f
  .elseif edx==2042
  	mov eax,HWND_TOP
  	mov ecx,SWP_NOSIZE OR SWP_NOMOVE OR SWP_FRAMECHANGED
  	jmp @f
  .elseif edx==2043
  	mov eax,HWND_BOTTOM
  	mov ecx,SWP_NOSIZE OR SWP_NOMOVE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE
@@:
    invoke SetWindowPos,hX,eax,0,0,0,0,ecx
;-----------------------------------------------------------------------------
  .elseif edx==2009
  	invoke IsWindowEnabled,hX
  	xor eax,1
  	invoke EnableWindow,hX,eax
;-----------------------------------------------------------------------------
  .elseif edx==2010
  	invoke IsIconic,hX
  	.if eax!=0
  		mov	eax,SW_RESTORE
  	.else
  		invoke IsZoomed,hX
  		.if eax!=0
  			mov	eax,SW_RESTORE
  		.else
  			mov eax,SW_MINIMIZE
  		.endif
  	.endif
  	invoke ShowWindow,hX,eax
;-----------------------------------------------------------------------------
  .elseif edx==2011
  	invoke IsWindowVisible,hX
  	.if eax==0
  		mov eax,SW_SHOWNORMAL
  	.else
  		mov eax,SW_HIDE
  	.endif
  	invoke ShowWindow,hX,eax
;-----------------------------------------------------------------------------
  .elseif edx==2014
  	mov ebx,WS_POPUP
  	jmp @f
  .elseif edx==2012
  	mov ebx,WS_CLIPCHILDREN
  	jmp @f
  .elseif edx==2025
  	mov ebx,WS_CHILD
  	invoke GetWindowLong,hX,GWL_ID
  	mov edi,eax
@@:
    invoke StyleTrigger,hX,ebx
    .if ebx==WS_CHILD
    	invoke GetWindowLong,hX,GWL_ID
    	.if eax!=edi
;    		and edi,0ffffh
    		invoke SetDlgItemInt,hWnd,2016,edi,0
    		invoke GetDlgItem,hWnd,2029
    		invoke EnableWindow,eax,1
    	.endif
    .endif
;-----------------------------------------------------------------------------
  .elseif edx==2007					                ; Top-L: all top-level windows (+ message-only)
  	mov eax,0
;   mov eax,-1
  	jmp @f
  .elseif edx==2019													; All:   all windows (+ message-only)
  	mov eax,1
  	jmp @f
  .elseif edx==2035													; Branch:  root branch of window tree
  	mov eax,4
  	jmp @f
  .elseif edx==2023													; Pid:   all PID(hP)-windows (+ message-only)
  	mov eax,2
  	jmp @f
  .elseif edx==2024													; Tid:   all TID(hP)-windows (+ message-only)
  	mov eax,3
  	jmp @f
  .elseif edx==2046													; Point: all following windows: cursor over WindowRect + PtInRgn
    mov eax,5
@@:
    mov filter,eax
    invoke CombolCaption
    mov edi,SWP_NOZORDER OR SWP_NOMOVE OR SWP_FRAMECHANGED
@@:
    invoke SendMessage,hw_combol,LB_RESETCONTENT,0,0
    invoke FillCombo
@@b:
    invoke SendMessage,hw_combol,LB_GETITEMHEIGHT,0,0
    mov ebx,eax
    add ebx,ebx
    invoke GetWindowRect,hw_combol,addr rt
    add rt.bottom,ebx
    mov eax,rt.right
    sub eax,rt.left
    mov ecx,rt.bottom
    sub ecx,rt.top
    invoke SetWindowPos,hw_combol,0,0,0,eax,ecx,edi
;-----------------------------------------------------------------------------
  .elseif edx==2030
  	invoke IsWindowVisible,hw_combol
  	mov ebx,eax
  	invoke GetWindowLong,hw_combol,GWL_STYLE
  	.if ebx!=0
  		and eax,not (WS_CAPTION OR WS_THICKFRAME OR WS_POPUP)
  		or eax,WS_BORDER
  		mov edi,SWP_NOZORDER OR SWP_NOMOVE OR SWP_FRAMECHANGED OR SWP_HIDEWINDOW
  		invoke SetWindowLong,hw_combol,GWL_STYLE,eax
  		jmp @@b
  	.else
  		or eax,WS_CAPTION OR WS_THICKFRAME OR WS_POPUP OR WS_BORDER
;  		and eax,not WS_CHILD ; //   "and",  MS (  XP Explorer   DDEMLEvent  WS_POPUP|WS_CHILD,   :-) )
  		mov edi,SWP_NOZORDER OR SWP_NOMOVE OR SWP_FRAMECHANGED OR SWP_SHOWWINDOW
  		invoke SetWindowLong,hw_combol,GWL_STYLE,eax
  		jmp @b
  	.endif
;-----------------------------------------------------------------------------
  .elseif edx==2037
    mov ebx,WS_EX_TOOLWINDOW
    jmp @f
  .elseif edx==2039
    mov ebx,WS_EX_APPWINDOW
@@:
  invoke IsWindowVisible,hP
  push eax
  invoke ShowWindow,hP,SW_HIDE
  invoke GetWindowLong,hP,GWL_EXSTYLE
  xor eax,ebx
  invoke SetWindowLong,hP,GWL_EXSTYLE,eax
  invoke SetWindowPos,hP,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
  pop eax
  .if eax!=0
    invoke ShowWindow,hP,SW_SHOW
  .endif
;-----------------------------------------------------------------------------
  .elseif edx==2050
    invoke SetWindowPos,hW,hP,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE
;-----------------------------------------------------------------------------
  .elseif edx==2044
    mov ebx,hX ; hP
    cmp ebx,hwMessage ; (XP-pro-sp2)
    jz @err
;@@: 	
    invoke GetWindow,ebx,GW_HWNDPREV        ; z-up
    test eax,eax
    jz @err
    mov ebx,eax

;    invoke GetAncestor,ebx,GA_ROOTOWNER
;    cmp eax,hX
;    jz @b
;    invoke GetWindow,ebx,GW_HWNDPREV
;    jmp @f

;    invoke GetWindowLong,hX,GWL_EXSTYLE
;    mov edi,eax
;    invoke GetWindowLong,ebx,GWL_EXSTYLE
;    mov ecx,WS_EX_TOPMOST
;    and eax,ecx
;    mov edx,edi
;    or edx,ecx
;    .if eax!=0 && edx!=edi
;;      invoke SetWindowLong,hX,GWL_EXSTYLE,edx
;      invoke SetWindowPos,hX,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE ; or SWP_NOACTIVATE
;      invoke SetWindowPos,hX,ebx,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE
;    .endif

    invoke SetWindowPos,ebx,hX,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE
;-----------------------------------------------------------------------------    
  .elseif edx==2045
  	invoke GetWindow,hX,GW_HWNDNEXT         ; z-down
  	test eax,eax
  	jz @err
;@@:
    invoke SetWindowPos,hX,eax,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE
;-----------------------------------------------------------------------------
  .elseif edx==2049
;  	invoke GetAncestor,hP,GA_PARENT  ; - Win95
    invoke GetGaParent,hP
  	jmp @ga_p
;-----------------------------------------------------------------------------
  .elseif edx==2031					; Z-order for siblings
  	mov eax,GW_HWNDFIRST
  	jmp @f
;-----------------------------------------------------------------------------
  .elseif edx==2032
  	mov eax,GW_HWNDPREV
  	jmp @f
;-----------------------------------------------------------------------------
  .elseif edx==2033
  	mov eax,GW_HWNDNEXT
  	jmp @f
;-----------------------------------------------------------------------------
  .elseif edx==2034
  	mov eax,GW_HWNDLAST
  	jmp @f
;-----------------------------------------------------------------------------
  .elseif edx==2048
  	mov eax,GW_CHILD
@@:
    mov ecx,hwMessage  ; (XP-pro-sp2)
    .if ecx==hP && eax!=GW_CHILD
@err:
;      invoke MessageBox,hWnd,offset _HWND_MESS+4,0,40000h
      invoke MessageBeep,MB_ICONHAND
    .else
    	invoke GetWindow,hP,eax
@ga_p:
      .if eax!=0
      	mov hP,eax
      	invoke SendMessage,hw_combo,CB_GETCOUNT,0,0
      	mov ebx,eax
      	.while ebx!=0
      		dec ebx
      		invoke SendMessage,hw_combo,CB_GETITEMDATA,ebx,0
      		.if eax==hP
      			invoke SendMessage,hw_combo,CB_SETCURSEL,ebx,0
      			.break
      		.endif
      	.endw
      .endif
  	.endif
  .endif
	ret
OnCommand endp

;########################################################################

DlgProc proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	local pt:POINT, rt:RECT
	mov eax,uMsg
	mov ecx,wParam
	mov edx,lParam
;------------------------------------------------------------------------
	.if eax==WM_CLOSE
		invoke GetAsyncKeyState,VK_F8
		and eax,8000h
		mov ebx,eax
		invoke GetAsyncKeyState,VK_F9
		and eax,8000h
		.if eax==0 || ebx==0
			invoke FullUndo
		.endif
		invoke KillTimer,hWnd,timerid
		invoke DeleteObject,hrgn
		invoke DeleteObject,hfont
		invoke EndDialog,hWnd,0
;------------------------------------------------------------------------
  .elseif eax==WM_INITDIALOG
    invoke OnInitDialog,hWnd
;------------------------------------------------------------------------
	.elseif eax==WM_TIMER && ecx==timerid
    invoke IsDlgButtonChecked,hWnd,2027
    .if eax==BST_UNCHECKED
      invoke KillTimer,hWnd,timerid
    .else
      invoke OnTimer,hWnd
    .endif
;------------------------------------------------------------------------
	.elseif eax==WM_COMMAND
    invoke OnCommand,hWnd,wParam,lParam
;------------------------------------------------------------------------
	.elseif eax==WM_SETCURSOR && (dx==HTTOP || dx==HTBOTTOM)
		mov eax,IDC_ARROW
		jmp @f
	.elseif eax==WM_SETCURSOR && (dx==HTTOPLEFT || dx==HTTOPRIGHT || dx==HTBOTTOMLEFT || dx==HTBOTTOMRIGHT)
		mov eax,IDC_SIZEWE  ; <->
@@:
		invoke LoadCursor,0,eax
		invoke SetCursor,eax
;------------------------------------------------------------------------
	.elseif eax==WM_SYSCOMMAND && wParam==idm_help
		invoke GetWindowRect,hWnd,addr rt
		mov ebx,50
		mov eax,rt.right
    mov ecx,rt.left
    add ecx,ebx
    sub eax,ecx
    mov edx,rt.bottom
    add ebx,rt.top
    sub edx,ebx
		invoke CreateWindowEx,\
		  WS_EX_TOPMOST or WS_EX_TOOLWINDOW or WS_EX_CLIENTEDGE,\
			offset _edit,offset prehelp,\
			WS_POPUP or WS_VISIBLE or WS_VSCROLL or WS_HSCROLL or WS_THICKFRAME or ES_MULTILINE or ES_READONLY,\
			ecx,ebx,eax,edx,hWnd,0,hinst,0
		mov ebx,eax
		invoke SetWindowLong,ebx,GWL_WNDPROC,addr NewEdit
		invoke SetWindowLong,ebx,GWL_USERDATA,eax
		invoke GetStockObject,DEFAULT_GUI_FONT
;		invoke SendMessage,hWnd,WM_GETFONT,0,0
		invoke SendMessage,ebx,WM_SETFONT,eax,TRUE
		invoke SendMessage,ebx,EM_SETSEL,0,80
;------------------------------------------------------------------------
	.elseif eax==WM_LBUTTONDOWN || (eax==WM_NCLBUTTONDOWN && wParam==HTBOTTOM)
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam
;------------------------------------------------------------------------
	.elseif eax==WM_NCRBUTTONDOWN && wParam==HTCAPTION
		invoke DefWindowProc,hWnd,0313h,0,lParam		; 0x0313 = undocumented (?)
;		invoke PostMessage,hWnd,0313h,0,lParam
;------------------------------------------------------------------------
	.elseif eax==WM_GETMINMAXINFO
		mov eax,lParam
		mov ecx,MinDlgWidth
		mov dword ptr [eax+6*4],ecx
		mov ecx,DlgHeight
		mov dword ptr [eax+7*4],ecx
		mov dword ptr [eax+9*4],ecx
;------------------------------------------------------------------------
	.elseif eax==WM_CTLCOLORLISTBOX
		.if mon!=0
			push eax
			invoke SetTextColor,wParam,00dd0000h
			pop eax
		.else
			mov eax,FALSE
		.endif
		jmp @f
;------------------------------------------------------------------------
	.elseif eax==WM_CTLCOLORSTATIC
;	  invoke GetLastActivePopup,hWnd
		mov edx,lParam
		.if edx==hw_2001 ; || edx==eax
      invoke SetBkMode,wParam,TRANSPARENT
			invoke SetTextColor,wParam,0
			invoke GetStockObject,WHITE_BRUSH      
		.else
			mov eax,FALSE
		.endif
		jmp @f
;------------------------------------------------------------------------
	.elseif eax==WM_CONTEXTMENU
		invoke GetCursorPos,addr pt
		invoke MapWindowPoints,0,hWnd,addr pt,1
		invoke ChildWindowFromPoint,hWnd,pt.x,pt.y
		.if eax!=hWnd
			mov ebx,eax
			invoke IsWindowEnabled,ebx
			xor eax,1
			invoke EnableWindow,ebx,eax
		.else
			mov eax,FALSE
			jmp @f
		.endif
;------------------------------------------------------------------------
	.else
		mov eax,FALSE
		jmp @f
	.endif
	mov eax,TRUE
@@:
	ret
DlgProc endp

;########################################################################

start:
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke DialogBoxParam,eax,offset DlgName,0,offset DlgProc,0
	invoke ExitProcess,eax
	invoke InitCommonControls
end start

;########################################################################

; MSDN -> Window Features -> Owned Windows :
;   * An owned window is always above its owner in the z-order.
;   * The system automatically destroys an owned window when its owner is destroyed.
;   * An owned window is hidden when its owner is minimized.
; ... After creating an owned window, an application cannot transfer ownership of the window to another window.
;  << SOMETIMES  IT  ISN'T  TRUE !..>>
; MSDN -> SetWindowLong Function :
; ... You must not call SetWindowLong with the GWL_HWNDPARENT index to change the parent of a child window.
;   Instead, use the SetParent function.
;  << NOTHING  ABOUT  OWNER  HERE !..>>",13,10,13,10,13,10
; MSDN -> SetParent Function :
; ... An application can use the SetParent function to set the parent window of a pop-up, overlapped, or child window.
;   The new parent window and the child window must belong to the same application.
;  << NOT  ALWAYS ,  NOT  ALWAYS !..>>
; ... if hWndNewParent is NULL, you should also clear the WS_CHILD bit and set the WS_POPUP style after calling SetParent.
;   Conversely, if hWndNewParent is not NULL and the window was previously a child of the desktop,
;   you should clear the WS_POPUP style and set the WS_CHILD style before calling SetParent.
;   Windows 2000/XP: When you change the parent of a window, you should synchronize the UISTATE of both windows.
; 	For more information, see WM_CHANGEUISTATE and WM_UPDATEUISTATE.

;########################################################################
